///////////////////////////////
// ResponsiveSwitch.js 1.0.3 //
// 2013-11-11                //
// SYNCK GRAPHICA            //
// www.synck.com             //
///////////////////////////////

function ResponsiveSwitch(json){
	var lib = {
		json: json,
		primary: json.id+'_primary',
		secondary: json.id+'_secondary',
		controller: json.id+'_controller',
		interval: null,
		stat: true,
		$: function(id){
			return document.getElementById(id);
		},
		init: function(){
			lib.add(window,"load",function(){
				if(!document.getElementById(lib.primary)){
					var elm = document.createElement('div');
					elm.id = lib.primary;
					elm.className = lib.primary;
					elm.innerHTML = lib.json.contents[lib.json.current];
					document.getElementById(lib.json.id).appendChild(elm);
				};
				if(!document.getElementById(lib.secondary)){
					var elm = document.createElement('div');
					elm.id = lib.secondary;
					elm.className = lib.secondary;
					document.getElementById(lib.json.id).appendChild(elm);
				};
				if(document.getElementById(lib.controller)){
					var control = document.createElement('ul');
					for(var i=0;i<lib.json.contents.length;i++){
						var elm = document.createElement('li');
						elm.id = lib.controller+'_'+i;
						elm.innerHTML = i+1;
						elm.onclick = function(){
							lib.change(this.id);
						};
						control.appendChild(elm);
					};
					document.getElementById(lib.controller).appendChild(control);
				};
				document.getElementById(lib.json.id).onmouseover = function(){
					lib.stop();
				};
				document.getElementById(lib.json.id).onmouseout = function(){
					lib.restart();
				};
				if(document.getElementById(lib.controller+'_'+lib.json.current))
					document.getElementById(lib.controller+'_'+lib.json.current).className = 'rs_current';
				lib.toggle();
			});
		},
		stop: function(){
			clearTimeout(lib.interval);
			lib.interval = null;
		},
		restart: function(){
			clearTimeout(lib.interval);
			lib.interval = setTimeout(function(){
				lib.toggle();
			},lib.json.interval);
		},
		change: function(num){
			num = parseInt(num.replace(lib.controller+'_',''));
			lib.json.current = (lib.json.contents.length + num - 1) % lib.json.contents.length;
			lib.dissolve();
		},
		toggle: function(){
			clearTimeout(lib.interval);
			lib.interval = setTimeout(function(){
				lib.dissolve();
			},lib.json.interval);
		},
		current: function(){
			
		},
		dissolve: function(){
			clearTimeout(lib.interval);
			lib.toggle();
			if(document.getElementById(lib.controller+'_'+lib.json.current))
				document.getElementById(lib.controller+'_'+lib.json.current).className = '';
			lib.json.current++;
			lib.json.current = lib.json.current % lib.json.contents.length;
			if(document.getElementById(lib.controller+'_'+lib.json.current))
				document.getElementById(lib.controller+'_'+lib.json.current).className = 'rs_current';
			lib.$(lib.secondary).innerHTML = lib.json.contents[lib.json.current];
			lib.$(lib.secondary).style.zIndex = 2;
			lib.$(lib.primary).style.zIndex = 1;
			lib.$(lib.secondary).className = lib.primary;
			setTimeout(function(){
				lib.$(lib.primary).innerHTML = lib.$(lib.secondary).innerHTML;
				lib.$(lib.secondary).style.zIndex = 1;
				lib.$(lib.primary).style.zIndex = 2;
				lib.$(lib.secondary).className = lib.secondary;
			},lib.json.speed);
		},
		add: function(elm,listener,fn){
			try { elm.addEventListener(listener,fn,false);}
			catch(e){ elm.attachEvent("on"+listener,fn);}
		}
	}
	this.lib = lib;
	this.lib.init();
}
